// TSLib - A free TeamSpeak 3 and 5 client library
// Copyright (C) 2017  TSLib contributors
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the Open Software License v. 3.0
//
// You should have received a copy of the Open Software License along with this
// program. If not, see <https://opensource.org/licenses/OSL-3.0>.
// <auto-generated />









using TSLib.Helper;

namespace TSLib
{
	// Source: https://www.tsviewer.com/index.php?page=faq&id=12&newlanguage=en
	public enum TsPermission
	{
		// ReSharper disable InconsistentNaming, UnusedMember.Global
		undefined,
		/// <summary>May occour on error returns with no associated permission</summary>
		unknown,
		/// <summary>Retrieve information about ServerQuery commands</summary>
		b_serverinstance_help_view,
		/// <summary>Retrieve global server version (including platform and build number)</summary>
		b_serverinstance_version_view,
		/// <summary>Retrieve global server information</summary>
		b_serverinstance_info_view,
		/// <summary>List virtual servers stored in the database</summary>
		b_serverinstance_virtualserver_list,
		/// <summary>List active IP bindings on multi-homed machines</summary>
		b_serverinstance_binding_list,
		/// <summary>List permissions available available on the server instance</summary>
		b_serverinstance_permission_list,
		/// <summary>Search permission assignments by name or ID</summary>
		b_serverinstance_permission_find,
		/// <summary>Create virtual servers</summary>
		b_virtualserver_create,
		/// <summary>Delete virtual servers</summary>
		b_virtualserver_delete,
		/// <summary>Start any virtual server in the server instance</summary>
		b_virtualserver_start_any,
		/// <summary>Stop any virtual server in the server instance</summary>
		b_virtualserver_stop_any,
		/// <summary>Change a virtual servers machine ID</summary>
		b_virtualserver_change_machine_id,
		/// <summary>Edit virtual server default template values</summary>
		b_virtualserver_change_template,
		/// <summary>Login to ServerQuery</summary>
		b_serverquery_login,
		/// <summary>Send text messages to all virtual servers at once</summary>
		b_serverinstance_textmessage_send,
		/// <summary>Retrieve global server log</summary>
		b_serverinstance_log_view,
		/// <summary>Write to global server log</summary>
		b_serverinstance_log_add,
		/// <summary>Shutdown the server process</summary>
		b_serverinstance_stop,
		/// <summary>Edit global settings</summary>
		b_serverinstance_modify_settings,
		/// <summary>Edit global ServerQuery groups</summary>
		b_serverinstance_modify_querygroup,
		/// <summary>Edit global template groups</summary>
		b_serverinstance_modify_templates,
		/// <summary>Select a virtual server</summary>
		b_virtualserver_select,
		/// <summary>Retrieve virtual server information</summary>
		b_virtualserver_info_view,
		/// <summary>Retrieve virtual server connection information</summary>
		b_virtualserver_connectioninfo_view,
		/// <summary>List channels on a virtual server</summary>
		b_virtualserver_channel_list,
		/// <summary>Search for channels on a virtual server</summary>
		b_virtualserver_channel_search,
		/// <summary>List clients online on a virtual server</summary>
		b_virtualserver_client_list,
		/// <summary>Search for clients online on a virtual server</summary>
		b_virtualserver_client_search,
		/// <summary>List client identities known by the virtual server</summary>
		b_virtualserver_client_dblist,
		/// <summary>Search for client identities known by the virtual server</summary>
		b_virtualserver_client_dbsearch,
		/// <summary>Retrieve client information</summary>
		b_virtualserver_client_dbinfo,
		/// <summary>Find permissions</summary>
		b_virtualserver_permission_find,
		/// <summary>Find custom fields</summary>
		b_virtualserver_custom_search,
		/// <summary>Start own virtual server</summary>
		b_virtualserver_start,
		/// <summary>Stop own virtual server</summary>
		b_virtualserver_stop,
		/// <summary>List privilege keys available</summary>
		b_virtualserver_token_list,
		/// <summary>Create new privilege keys</summary>
		b_virtualserver_token_add,
		/// <summary>Use a privilege keys to gain access to groups</summary>
		b_virtualserver_token_use,
		/// <summary>Delete a privilege key</summary>
		b_virtualserver_token_delete,
		/// <summary>Retrieve virtual server log</summary>
		b_virtualserver_log_view,
		/// <summary>Write to virtual server log</summary>
		b_virtualserver_log_add,
		/// <summary>Join virtual server ignoring its password</summary>
		b_virtualserver_join_ignore_password,
		/// <summary>Register for server notifications</summary>
		b_virtualserver_notify_register,
		/// <summary>Unregister from server notifications</summary>
		b_virtualserver_notify_unregister,
		/// <summary>Create server snapshots</summary>
		b_virtualserver_snapshot_create,
		/// <summary>Deploy server snapshots</summary>
		b_virtualserver_snapshot_deploy,
		/// <summary>Reset the server permission settings to default values</summary>
		b_virtualserver_permission_reset,
		/// <summary>Modify server name</summary>
		b_virtualserver_modify_name,
		/// <summary>Modify welcome message</summary>
		b_virtualserver_modify_welcomemessage,
		/// <summary>Modify servers max clients</summary>
		b_virtualserver_modify_maxclients,
		/// <summary>Modify reserved slots</summary>
		b_virtualserver_modify_reserved_slots,
		/// <summary>Modify server password</summary>
		b_virtualserver_modify_password,
		/// <summary>Modify default Server Group</summary>
		b_virtualserver_modify_default_servergroup,
		/// <summary>Modify default Channel Group</summary>
		b_virtualserver_modify_default_channelgroup,
		/// <summary>Modify default Channel Admin Group</summary>
		b_virtualserver_modify_default_channeladmingroup,
		/// <summary>Modify channel force silence value</summary>
		b_virtualserver_modify_channel_forced_silence,
		/// <summary>Modify individual complain settings</summary>
		b_virtualserver_modify_complain,
		/// <summary>Modify individual antiflood settings</summary>
		b_virtualserver_modify_antiflood,
		/// <summary>Modify file transfer settings</summary>
		b_virtualserver_modify_ft_settings,
		/// <summary>Modify file transfer quotas</summary>
		b_virtualserver_modify_ft_quotas,
		/// <summary>Modify individual hostmessage settings</summary>
		b_virtualserver_modify_hostmessage,
		/// <summary>Modify individual hostbanner settings</summary>
		b_virtualserver_modify_hostbanner,
		/// <summary>Modify individual hostbutton settings</summary>
		b_virtualserver_modify_hostbutton,
		/// <summary>Modify server port</summary>
		b_virtualserver_modify_port,
		/// <summary>Modify server autostart</summary>
		b_virtualserver_modify_autostart,
		/// <summary>Modify required identity security level</summary>
		b_virtualserver_modify_needed_identity_security_level,
		/// <summary>Modify priority speaker dimm modificator</summary>
		b_virtualserver_modify_priority_speaker_dimm_modificator,
		/// <summary>Modify log settings</summary>
		b_virtualserver_modify_log_settings,
		/// <summary>Modify min client version</summary>
		b_virtualserver_modify_min_client_version,
		/// <summary>Modify server icon</summary>
		b_virtualserver_modify_icon_id,
		/// <summary>Modify web server list reporting settings</summary>
		b_virtualserver_modify_weblist,
		/// <summary>Modify codec encryption mode</summary>
		b_virtualserver_modify_codec_encryption_mode,
		/// <summary>Modify temporary serverpasswords</summary>
		b_virtualserver_modify_temporary_passwords,
		/// <summary>Modify own temporary serverpasswords</summary>
		b_virtualserver_modify_temporary_passwords_own,
		/// <summary>Modify default temporary channel delete delay</summary>
		b_virtualserver_modify_channel_temp_delete_delay_default,
		/// <summary>Modify server nicknames</summary>
		b_virtualserver_modify_nickname,
		/// <summary>Modify integrations</summary>
		b_virtualserver_modify_integrations,
		/// <summary>Min channel creation depth in hierarchy</summary>
		i_channel_min_depth,
		/// <summary>Max channel creation depth in hierarchy</summary>
		i_channel_max_depth,
		/// <summary>Stop inheritance of channel group permissions</summary>
		b_channel_group_inheritance_end,
		/// <summary>Modify channel permission power</summary>
		i_channel_permission_modify_power,
		/// <summary>Needed modify channel permission power</summary>
		i_channel_needed_permission_modify_power,
		/// <summary>Retrieve channel information</summary>
		b_channel_info_view,
		/// <summary>Create sub-channels</summary>
		b_channel_create_child,
		/// <summary>Create permanent channels</summary>
		b_channel_create_permanent,
		/// <summary>Create semi-permanent channels</summary>
		b_channel_create_semi_permanent,
		/// <summary>Create temporary channels</summary>
		b_channel_create_temporary,
		/// <summary>Create private channel</summary>
		b_channel_create_private,
		/// <summary>Create channels with a topic</summary>
		b_channel_create_with_topic,
		/// <summary>Create channels with a description</summary>
		b_channel_create_with_description,
		/// <summary>Create password protected channels</summary>
		b_channel_create_with_password,
		/// <summary>Create channels using Speex Narrowband (8 kHz) codecs</summary>
		b_channel_create_modify_with_codec_speex8,
		/// <summary>Create channels using Speex Wideband (16 kHz) codecs</summary>
		b_channel_create_modify_with_codec_speex16,
		/// <summary>Create channels using Speex Ultra-Wideband (32 kHz) codecs</summary>
		b_channel_create_modify_with_codec_speex32,
		/// <summary>Create channels using the CELT Mono (48 kHz) codec</summary>
		b_channel_create_modify_with_codec_celtmono48,
		/// <summary>Create channels using OPUS (voice) codec</summary>
		b_channel_create_modify_with_codec_opusvoice,
		/// <summary>Create channels using OPUS (music) codec</summary>
		b_channel_create_modify_with_codec_opusmusic,
		/// <summary>Create channels with custom codec quality</summary>
		i_channel_create_modify_with_codec_maxquality,
		/// <summary>Create channels with minimal custom codec latency factor</summary>
		i_channel_create_modify_with_codec_latency_factor_min,
		/// <summary>Create channels with custom max clients</summary>
		b_channel_create_with_maxclients,
		/// <summary>Create channels with custom max family clients</summary>
		b_channel_create_with_maxfamilyclients,
		/// <summary>Create channels with custom sort order</summary>
		b_channel_create_with_sortorder,
		/// <summary>Create default channels</summary>
		b_channel_create_with_default,
		/// <summary>Create channels with needed talk power</summary>
		b_channel_create_with_needed_talk_power,
		/// <summary>Create new channels only with password</summary>
		b_channel_create_modify_with_force_password,
		/// <summary>Max delete delay for temporary channels</summary>
		i_channel_create_modify_with_temp_delete_delay,
		/// <summary>Move channels</summary>
		b_channel_modify_parent,
		/// <summary>Make channel default</summary>
		b_channel_modify_make_default,
		/// <summary>Make channel permanent</summary>
		b_channel_modify_make_permanent,
		/// <summary>Make channel semi-permanent</summary>
		b_channel_modify_make_semi_permanent,
		/// <summary>Make channel temporary</summary>
		b_channel_modify_make_temporary,
		/// <summary>Modify channel name</summary>
		b_channel_modify_name,
		/// <summary>Modify channel topic</summary>
		b_channel_modify_topic,
		/// <summary>Modify channel description</summary>
		b_channel_modify_description,
		/// <summary>Modify channel password</summary>
		b_channel_modify_password,
		/// <summary>Modify channel codec</summary>
		b_channel_modify_codec,
		/// <summary>Modify channel codec quality</summary>
		b_channel_modify_codec_quality,
		/// <summary>Modify channel codec latency factor</summary>
		b_channel_modify_codec_latency_factor,
		/// <summary>Modify channels max clients</summary>
		b_channel_modify_maxclients,
		/// <summary>Modify channels max family clients</summary>
		b_channel_modify_maxfamilyclients,
		/// <summary>Modify channel sort order</summary>
		b_channel_modify_sortorder,
		/// <summary>Change needed channel talk power</summary>
		b_channel_modify_needed_talk_power,
		/// <summary>Channel modify power</summary>
		i_channel_modify_power,
		/// <summary>Needed channel modify power</summary>
		i_channel_needed_modify_power,
		/// <summary>Make channel codec encrypted</summary>
		b_channel_modify_make_codec_encrypted,
		/// <summary>Modify temporary channel delete delay</summary>
		b_channel_modify_temp_delete_delay,
		/// <summary>Delete permanent channels</summary>
		b_channel_delete_permanent,
		/// <summary>Delete semi-permanent channels</summary>
		b_channel_delete_semi_permanent,
		/// <summary>Delete temporary channels</summary>
		b_channel_delete_temporary,
		/// <summary>Force channel delete</summary>
		b_channel_delete_flag_force,
		/// <summary>Delete channel power</summary>
		i_channel_delete_power,
		/// <summary>Needed delete channel power</summary>
		i_channel_needed_delete_power,
		/// <summary>Join permanent channels</summary>
		b_channel_join_permanent,
		/// <summary>Join semi-permanent channels</summary>
		b_channel_join_semi_permanent,
		/// <summary>Join temporary channels</summary>
		b_channel_join_temporary,
		/// <summary>Join channel ignoring its password</summary>
		b_channel_join_ignore_password,
		/// <summary>Ignore channels max clients limit</summary>
		b_channel_join_ignore_maxclients,
		/// <summary>Channel join power</summary>
		i_channel_join_power,
		/// <summary>Needed channel join power</summary>
		i_channel_needed_join_power,
		/// <summary>Channel subscribe power</summary>
		i_channel_subscribe_power,
		/// <summary>Needed channel subscribe power</summary>
		i_channel_needed_subscribe_power,
		/// <summary>Channel description view power</summary>
		i_channel_description_view_power,
		/// <summary>Needed channel needed description view power</summary>
		i_channel_needed_description_view_power,
		/// <summary>Group icon identifier</summary>
		i_icon_id,
		/// <summary>Max icon filesize in bytes</summary>
		i_max_icon_filesize,
		/// <summary>Enables icon management</summary>
		b_icon_manage,
		/// <summary>Group is permanent</summary>
		b_group_is_permanent,
		/// <summary>Group auto-update type</summary>
		i_group_auto_update_type,
		/// <summary>Group auto-update max value</summary>
		i_group_auto_update_max_value,
		/// <summary>Group sort id</summary>
		i_group_sort_id,
		/// <summary>Show group name in tree depending on selected mode</summary>
		i_group_show_name_in_tree,
		/// <summary>List server groups</summary>
		b_virtualserver_servergroup_list,
		/// <summary>List server group permissions</summary>
		b_virtualserver_servergroup_permission_list,
		/// <summary>List clients from a server group</summary>
		b_virtualserver_servergroup_client_list,
		/// <summary>List channel groups</summary>
		b_virtualserver_channelgroup_list,
		/// <summary>List channel group permissions</summary>
		b_virtualserver_channelgroup_permission_list,
		/// <summary>List clients from a channel group</summary>
		b_virtualserver_channelgroup_client_list,
		/// <summary>List client permissions</summary>
		b_virtualserver_client_permission_list,
		/// <summary>List channel permissions</summary>
		b_virtualserver_channel_permission_list,
		/// <summary>List channel client permissions</summary>
		b_virtualserver_channelclient_permission_list,
		/// <summary>Create server groups</summary>
		b_virtualserver_servergroup_create,
		/// <summary>Create channel groups</summary>
		b_virtualserver_channelgroup_create,
		/// <summary>Group modify power</summary>
		i_group_modify_power,
		/// <summary>Needed group modify power</summary>
		i_group_needed_modify_power,
		/// <summary>Group member add power</summary>
		i_group_member_add_power,
		/// <summary>Needed group member add power</summary>
		i_group_needed_member_add_power,
		/// <summary>Group member delete power</summary>
		i_group_member_remove_power,
		/// <summary>Needed group member delete power</summary>
		i_group_needed_member_remove_power,
		/// <summary>Permission modify power</summary>
		i_permission_modify_power,
		/// <summary>Ignore needed permission modify power</summary>
		b_permission_modify_power_ignore,
		/// <summary>Delete server groups</summary>
		b_virtualserver_servergroup_delete,
		/// <summary>Delete channel groups</summary>
		b_virtualserver_channelgroup_delete,
		/// <summary>Client permission modify power</summary>
		i_client_permission_modify_power,
		/// <summary>Needed client permission modify power</summary>
		i_client_needed_permission_modify_power,
		/// <summary>Max additional connections per client identity</summary>
		i_client_max_clones_uid,
		/// <summary>Max idle time in seconds</summary>
		i_client_max_idletime,
		/// <summary>Max avatar filesize in bytes</summary>
		i_client_max_avatar_filesize,
		/// <summary>Max channel subscriptions</summary>
		i_client_max_channel_subscriptions,
		/// <summary>Client is priority speaker</summary>
		b_client_is_priority_speaker,
		/// <summary>Ignore channel group permissions</summary>
		b_client_skip_channelgroup_permissions,
		/// <summary>Force Push-To-Talk capture mode</summary>
		b_client_force_push_to_talk,
		/// <summary>Ignore bans</summary>
		b_client_ignore_bans,
		/// <summary>Ignore antiflood measurements</summary>
		b_client_ignore_antiflood,
		/// <summary>Issue query commands from client</summary>
		b_client_issue_client_query_command,
		/// <summary>Use an reserved slot</summary>
		b_client_use_reserved_slot,
		/// <summary>Use channel commander</summary>
		b_client_use_channel_commander,
		/// <summary>Allow to request talk power</summary>
		b_client_request_talker,
		/// <summary>Allow deletion of avatars from other clients</summary>
		b_client_avatar_delete_other,
		/// <summary>Client will be sticked to current channel</summary>
		b_client_is_sticky,
		/// <summary>Client ignores sticky flag</summary>
		b_client_ignore_sticky,
		/// <summary>Retrieve client information</summary>
		b_client_info_view,
		/// <summary>Retrieve client permissions overview</summary>
		b_client_permissionoverview_view,
		/// <summary>Retrieve clients own permissions overview</summary>
		b_client_permissionoverview_own,
		/// <summary>View client IP address and port</summary>
		b_client_remoteaddress_view,
		/// <summary>ServerQuery view power</summary>
		i_client_serverquery_view_power,
		/// <summary>Needed ServerQuery view power</summary>
		i_client_needed_serverquery_view_power,
		/// <summary>View custom fields</summary>
		b_client_custom_info_view,
		/// <summary>Client kick power from server</summary>
		i_client_kick_from_server_power,
		/// <summary>Needed client kick power from server</summary>
		i_client_needed_kick_from_server_power,
		/// <summary>Client kick power from channel</summary>
		i_client_kick_from_channel_power,
		/// <summary>Needed client kick power from channel</summary>
		i_client_needed_kick_from_channel_power,
		/// <summary>Client ban power</summary>
		i_client_ban_power,
		/// <summary>Needed client ban power</summary>
		i_client_needed_ban_power,
		/// <summary>Client move power</summary>
		i_client_move_power,
		/// <summary>Needed client move power</summary>
		i_client_needed_move_power,
		/// <summary>Complain power</summary>
		i_client_complain_power,
		/// <summary>Needed complain power</summary>
		i_client_needed_complain_power,
		/// <summary>Show complain list</summary>
		b_client_complain_list,
		/// <summary>Delete own complains</summary>
		b_client_complain_delete_own,
		/// <summary>Delete complains</summary>
		b_client_complain_delete,
		/// <summary>Show banlist</summary>
		b_client_ban_list,
		/// <summary>Add a ban</summary>
		b_client_ban_create,
		/// <summary>Delete own bans</summary>
		b_client_ban_delete_own,
		/// <summary>Delete bans</summary>
		b_client_ban_delete,
		/// <summary>Max bantime</summary>
		i_client_ban_max_bantime,
		/// <summary>Client private message power</summary>
		i_client_private_textmessage_power,
		/// <summary>Needed client private message power</summary>
		i_client_needed_private_textmessage_power,
		/// <summary>Send text messages to virtual server</summary>
		b_client_server_textmessage_send,
		/// <summary>Send text messages to channel</summary>
		b_client_channel_textmessage_send,
		/// <summary>Send offline messages to clients</summary>
		b_client_offline_textmessage_send,
		/// <summary>Client talk power</summary>
		i_client_talk_power,
		/// <summary>Needed client talk power</summary>
		i_client_needed_talk_power,
		/// <summary>Client poke power</summary>
		i_client_poke_power,
		/// <summary>Needed client poke power</summary>
		i_client_needed_poke_power,
		/// <summary>Set the talker flag for clients and allow them to speak</summary>
		b_client_set_flag_talker,
		/// <summary>Client whisper power</summary>
		i_client_whisper_power,
		/// <summary>Client needed whisper power</summary>
		i_client_needed_whisper_power,
		/// <summary>Edit a clients description</summary>
		b_client_modify_description,
		/// <summary>Allow client to edit own description</summary>
		b_client_modify_own_description,
		/// <summary>Edit a clients properties in the database</summary>
		b_client_modify_dbproperties,
		/// <summary>Delete a clients properties in the database</summary>
		b_client_delete_dbproperties,
		/// <summary>Create or modify own ServerQuery account</summary>
		b_client_create_modify_serverquery_login,
		/// <summary>Browse files without channel password</summary>
		b_ft_ignore_password,
		/// <summary>Retrieve list of running filetransfers</summary>
		b_ft_transfer_list,
		/// <summary>File upload power</summary>
		i_ft_file_upload_power,
		/// <summary>Needed file upload power</summary>
		i_ft_needed_file_upload_power,
		/// <summary>File download power</summary>
		i_ft_file_download_power,
		/// <summary>Needed file download power</summary>
		i_ft_needed_file_download_power,
		/// <summary>File delete power</summary>
		i_ft_file_delete_power,
		/// <summary>Needed file delete power</summary>
		i_ft_needed_file_delete_power,
		/// <summary>File rename power</summary>
		i_ft_file_rename_power,
		/// <summary>Needed file rename power</summary>
		i_ft_needed_file_rename_power,
		/// <summary>File browse power</summary>
		i_ft_file_browse_power,
		/// <summary>Needed file browse power</summary>
		i_ft_needed_file_browse_power,
		/// <summary>Create directory power</summary>
		i_ft_directory_create_power,
		/// <summary>Needed create directory power</summary>
		i_ft_needed_directory_create_power,
		/// <summary>Download quota per client in MByte</summary>
		i_ft_quota_mb_download_per_client,
		/// <summary>Upload quota per client in MByte</summary>
		i_ft_quota_mb_upload_per_client,
		// ReSharper restore InconsistentNaming, UnusedMember.Global
	}

	public static partial class TsPermissionHelper
	{
		public static string GetDescription(TsPermission permid)
		{
			switch (permid)
			{
			case TsPermission.undefined: return "Undefined permission";
			case TsPermission.unknown: return "May occour on error returns with no associated permission";
			case TsPermission.b_serverinstance_help_view: return "Retrieve information about ServerQuery commands";
			case TsPermission.b_serverinstance_version_view: return "Retrieve global server version (including platform and build number)";
			case TsPermission.b_serverinstance_info_view: return "Retrieve global server information";
			case TsPermission.b_serverinstance_virtualserver_list: return "List virtual servers stored in the database";
			case TsPermission.b_serverinstance_binding_list: return "List active IP bindings on multi-homed machines";
			case TsPermission.b_serverinstance_permission_list: return "List permissions available available on the server instance";
			case TsPermission.b_serverinstance_permission_find: return "Search permission assignments by name or ID";
			case TsPermission.b_virtualserver_create: return "Create virtual servers";
			case TsPermission.b_virtualserver_delete: return "Delete virtual servers";
			case TsPermission.b_virtualserver_start_any: return "Start any virtual server in the server instance";
			case TsPermission.b_virtualserver_stop_any: return "Stop any virtual server in the server instance";
			case TsPermission.b_virtualserver_change_machine_id: return "Change a virtual servers machine ID";
			case TsPermission.b_virtualserver_change_template: return "Edit virtual server default template values";
			case TsPermission.b_serverquery_login: return "Login to ServerQuery";
			case TsPermission.b_serverinstance_textmessage_send: return "Send text messages to all virtual servers at once";
			case TsPermission.b_serverinstance_log_view: return "Retrieve global server log";
			case TsPermission.b_serverinstance_log_add: return "Write to global server log";
			case TsPermission.b_serverinstance_stop: return "Shutdown the server process";
			case TsPermission.b_serverinstance_modify_settings: return "Edit global settings";
			case TsPermission.b_serverinstance_modify_querygroup: return "Edit global ServerQuery groups";
			case TsPermission.b_serverinstance_modify_templates: return "Edit global template groups";
			case TsPermission.b_virtualserver_select: return "Select a virtual server";
			case TsPermission.b_virtualserver_info_view: return "Retrieve virtual server information";
			case TsPermission.b_virtualserver_connectioninfo_view: return "Retrieve virtual server connection information";
			case TsPermission.b_virtualserver_channel_list: return "List channels on a virtual server";
			case TsPermission.b_virtualserver_channel_search: return "Search for channels on a virtual server";
			case TsPermission.b_virtualserver_client_list: return "List clients online on a virtual server";
			case TsPermission.b_virtualserver_client_search: return "Search for clients online on a virtual server";
			case TsPermission.b_virtualserver_client_dblist: return "List client identities known by the virtual server";
			case TsPermission.b_virtualserver_client_dbsearch: return "Search for client identities known by the virtual server";
			case TsPermission.b_virtualserver_client_dbinfo: return "Retrieve client information";
			case TsPermission.b_virtualserver_permission_find: return "Find permissions";
			case TsPermission.b_virtualserver_custom_search: return "Find custom fields";
			case TsPermission.b_virtualserver_start: return "Start own virtual server";
			case TsPermission.b_virtualserver_stop: return "Stop own virtual server";
			case TsPermission.b_virtualserver_token_list: return "List privilege keys available";
			case TsPermission.b_virtualserver_token_add: return "Create new privilege keys";
			case TsPermission.b_virtualserver_token_use: return "Use a privilege keys to gain access to groups";
			case TsPermission.b_virtualserver_token_delete: return "Delete a privilege key";
			case TsPermission.b_virtualserver_log_view: return "Retrieve virtual server log";
			case TsPermission.b_virtualserver_log_add: return "Write to virtual server log";
			case TsPermission.b_virtualserver_join_ignore_password: return "Join virtual server ignoring its password";
			case TsPermission.b_virtualserver_notify_register: return "Register for server notifications";
			case TsPermission.b_virtualserver_notify_unregister: return "Unregister from server notifications";
			case TsPermission.b_virtualserver_snapshot_create: return "Create server snapshots";
			case TsPermission.b_virtualserver_snapshot_deploy: return "Deploy server snapshots";
			case TsPermission.b_virtualserver_permission_reset: return "Reset the server permission settings to default values";
			case TsPermission.b_virtualserver_modify_name: return "Modify server name";
			case TsPermission.b_virtualserver_modify_welcomemessage: return "Modify welcome message";
			case TsPermission.b_virtualserver_modify_maxclients: return "Modify servers max clients";
			case TsPermission.b_virtualserver_modify_reserved_slots: return "Modify reserved slots";
			case TsPermission.b_virtualserver_modify_password: return "Modify server password";
			case TsPermission.b_virtualserver_modify_default_servergroup: return "Modify default Server Group";
			case TsPermission.b_virtualserver_modify_default_channelgroup: return "Modify default Channel Group";
			case TsPermission.b_virtualserver_modify_default_channeladmingroup: return "Modify default Channel Admin Group";
			case TsPermission.b_virtualserver_modify_channel_forced_silence: return "Modify channel force silence value";
			case TsPermission.b_virtualserver_modify_complain: return "Modify individual complain settings";
			case TsPermission.b_virtualserver_modify_antiflood: return "Modify individual antiflood settings";
			case TsPermission.b_virtualserver_modify_ft_settings: return "Modify file transfer settings";
			case TsPermission.b_virtualserver_modify_ft_quotas: return "Modify file transfer quotas";
			case TsPermission.b_virtualserver_modify_hostmessage: return "Modify individual hostmessage settings";
			case TsPermission.b_virtualserver_modify_hostbanner: return "Modify individual hostbanner settings";
			case TsPermission.b_virtualserver_modify_hostbutton: return "Modify individual hostbutton settings";
			case TsPermission.b_virtualserver_modify_port: return "Modify server port";
			case TsPermission.b_virtualserver_modify_autostart: return "Modify server autostart";
			case TsPermission.b_virtualserver_modify_needed_identity_security_level: return "Modify required identity security level";
			case TsPermission.b_virtualserver_modify_priority_speaker_dimm_modificator: return "Modify priority speaker dimm modificator";
			case TsPermission.b_virtualserver_modify_log_settings: return "Modify log settings";
			case TsPermission.b_virtualserver_modify_min_client_version: return "Modify min client version";
			case TsPermission.b_virtualserver_modify_icon_id: return "Modify server icon";
			case TsPermission.b_virtualserver_modify_weblist: return "Modify web server list reporting settings";
			case TsPermission.b_virtualserver_modify_codec_encryption_mode: return "Modify codec encryption mode";
			case TsPermission.b_virtualserver_modify_temporary_passwords: return "Modify temporary serverpasswords";
			case TsPermission.b_virtualserver_modify_temporary_passwords_own: return "Modify own temporary serverpasswords";
			case TsPermission.b_virtualserver_modify_channel_temp_delete_delay_default: return "Modify default temporary channel delete delay";
			case TsPermission.b_virtualserver_modify_nickname: return "Modify server nicknames";
			case TsPermission.b_virtualserver_modify_integrations: return "Modify integrations";
			case TsPermission.i_channel_min_depth: return "Min channel creation depth in hierarchy";
			case TsPermission.i_channel_max_depth: return "Max channel creation depth in hierarchy";
			case TsPermission.b_channel_group_inheritance_end: return "Stop inheritance of channel group permissions";
			case TsPermission.i_channel_permission_modify_power: return "Modify channel permission power";
			case TsPermission.i_channel_needed_permission_modify_power: return "Needed modify channel permission power";
			case TsPermission.b_channel_info_view: return "Retrieve channel information";
			case TsPermission.b_channel_create_child: return "Create sub-channels";
			case TsPermission.b_channel_create_permanent: return "Create permanent channels";
			case TsPermission.b_channel_create_semi_permanent: return "Create semi-permanent channels";
			case TsPermission.b_channel_create_temporary: return "Create temporary channels";
			case TsPermission.b_channel_create_private: return "Create private channel";
			case TsPermission.b_channel_create_with_topic: return "Create channels with a topic";
			case TsPermission.b_channel_create_with_description: return "Create channels with a description";
			case TsPermission.b_channel_create_with_password: return "Create password protected channels";
			case TsPermission.b_channel_create_modify_with_codec_speex8: return "Create channels using Speex Narrowband (8 kHz) codecs";
			case TsPermission.b_channel_create_modify_with_codec_speex16: return "Create channels using Speex Wideband (16 kHz) codecs";
			case TsPermission.b_channel_create_modify_with_codec_speex32: return "Create channels using Speex Ultra-Wideband (32 kHz) codecs";
			case TsPermission.b_channel_create_modify_with_codec_celtmono48: return "Create channels using the CELT Mono (48 kHz) codec";
			case TsPermission.b_channel_create_modify_with_codec_opusvoice: return "Create channels using OPUS (voice) codec";
			case TsPermission.b_channel_create_modify_with_codec_opusmusic: return "Create channels using OPUS (music) codec";
			case TsPermission.i_channel_create_modify_with_codec_maxquality: return "Create channels with custom codec quality";
			case TsPermission.i_channel_create_modify_with_codec_latency_factor_min: return "Create channels with minimal custom codec latency factor";
			case TsPermission.b_channel_create_with_maxclients: return "Create channels with custom max clients";
			case TsPermission.b_channel_create_with_maxfamilyclients: return "Create channels with custom max family clients";
			case TsPermission.b_channel_create_with_sortorder: return "Create channels with custom sort order";
			case TsPermission.b_channel_create_with_default: return "Create default channels";
			case TsPermission.b_channel_create_with_needed_talk_power: return "Create channels with needed talk power";
			case TsPermission.b_channel_create_modify_with_force_password: return "Create new channels only with password";
			case TsPermission.i_channel_create_modify_with_temp_delete_delay: return "Max delete delay for temporary channels";
			case TsPermission.b_channel_modify_parent: return "Move channels";
			case TsPermission.b_channel_modify_make_default: return "Make channel default";
			case TsPermission.b_channel_modify_make_permanent: return "Make channel permanent";
			case TsPermission.b_channel_modify_make_semi_permanent: return "Make channel semi-permanent";
			case TsPermission.b_channel_modify_make_temporary: return "Make channel temporary";
			case TsPermission.b_channel_modify_name: return "Modify channel name";
			case TsPermission.b_channel_modify_topic: return "Modify channel topic";
			case TsPermission.b_channel_modify_description: return "Modify channel description";
			case TsPermission.b_channel_modify_password: return "Modify channel password";
			case TsPermission.b_channel_modify_codec: return "Modify channel codec";
			case TsPermission.b_channel_modify_codec_quality: return "Modify channel codec quality";
			case TsPermission.b_channel_modify_codec_latency_factor: return "Modify channel codec latency factor";
			case TsPermission.b_channel_modify_maxclients: return "Modify channels max clients";
			case TsPermission.b_channel_modify_maxfamilyclients: return "Modify channels max family clients";
			case TsPermission.b_channel_modify_sortorder: return "Modify channel sort order";
			case TsPermission.b_channel_modify_needed_talk_power: return "Change needed channel talk power";
			case TsPermission.i_channel_modify_power: return "Channel modify power";
			case TsPermission.i_channel_needed_modify_power: return "Needed channel modify power";
			case TsPermission.b_channel_modify_make_codec_encrypted: return "Make channel codec encrypted";
			case TsPermission.b_channel_modify_temp_delete_delay: return "Modify temporary channel delete delay";
			case TsPermission.b_channel_delete_permanent: return "Delete permanent channels";
			case TsPermission.b_channel_delete_semi_permanent: return "Delete semi-permanent channels";
			case TsPermission.b_channel_delete_temporary: return "Delete temporary channels";
			case TsPermission.b_channel_delete_flag_force: return "Force channel delete";
			case TsPermission.i_channel_delete_power: return "Delete channel power";
			case TsPermission.i_channel_needed_delete_power: return "Needed delete channel power";
			case TsPermission.b_channel_join_permanent: return "Join permanent channels";
			case TsPermission.b_channel_join_semi_permanent: return "Join semi-permanent channels";
			case TsPermission.b_channel_join_temporary: return "Join temporary channels";
			case TsPermission.b_channel_join_ignore_password: return "Join channel ignoring its password";
			case TsPermission.b_channel_join_ignore_maxclients: return "Ignore channels max clients limit";
			case TsPermission.i_channel_join_power: return "Channel join power";
			case TsPermission.i_channel_needed_join_power: return "Needed channel join power";
			case TsPermission.i_channel_subscribe_power: return "Channel subscribe power";
			case TsPermission.i_channel_needed_subscribe_power: return "Needed channel subscribe power";
			case TsPermission.i_channel_description_view_power: return "Channel description view power";
			case TsPermission.i_channel_needed_description_view_power: return "Needed channel needed description view power";
			case TsPermission.i_icon_id: return "Group icon identifier";
			case TsPermission.i_max_icon_filesize: return "Max icon filesize in bytes";
			case TsPermission.b_icon_manage: return "Enables icon management";
			case TsPermission.b_group_is_permanent: return "Group is permanent";
			case TsPermission.i_group_auto_update_type: return "Group auto-update type";
			case TsPermission.i_group_auto_update_max_value: return "Group auto-update max value";
			case TsPermission.i_group_sort_id: return "Group sort id";
			case TsPermission.i_group_show_name_in_tree: return "Show group name in tree depending on selected mode";
			case TsPermission.b_virtualserver_servergroup_list: return "List server groups";
			case TsPermission.b_virtualserver_servergroup_permission_list: return "List server group permissions";
			case TsPermission.b_virtualserver_servergroup_client_list: return "List clients from a server group";
			case TsPermission.b_virtualserver_channelgroup_list: return "List channel groups";
			case TsPermission.b_virtualserver_channelgroup_permission_list: return "List channel group permissions";
			case TsPermission.b_virtualserver_channelgroup_client_list: return "List clients from a channel group";
			case TsPermission.b_virtualserver_client_permission_list: return "List client permissions";
			case TsPermission.b_virtualserver_channel_permission_list: return "List channel permissions";
			case TsPermission.b_virtualserver_channelclient_permission_list: return "List channel client permissions";
			case TsPermission.b_virtualserver_servergroup_create: return "Create server groups";
			case TsPermission.b_virtualserver_channelgroup_create: return "Create channel groups";
			case TsPermission.i_group_modify_power: return "Group modify power";
			case TsPermission.i_group_needed_modify_power: return "Needed group modify power";
			case TsPermission.i_group_member_add_power: return "Group member add power";
			case TsPermission.i_group_needed_member_add_power: return "Needed group member add power";
			case TsPermission.i_group_member_remove_power: return "Group member delete power";
			case TsPermission.i_group_needed_member_remove_power: return "Needed group member delete power";
			case TsPermission.i_permission_modify_power: return "Permission modify power";
			case TsPermission.b_permission_modify_power_ignore: return "Ignore needed permission modify power";
			case TsPermission.b_virtualserver_servergroup_delete: return "Delete server groups";
			case TsPermission.b_virtualserver_channelgroup_delete: return "Delete channel groups";
			case TsPermission.i_client_permission_modify_power: return "Client permission modify power";
			case TsPermission.i_client_needed_permission_modify_power: return "Needed client permission modify power";
			case TsPermission.i_client_max_clones_uid: return "Max additional connections per client identity";
			case TsPermission.i_client_max_idletime: return "Max idle time in seconds";
			case TsPermission.i_client_max_avatar_filesize: return "Max avatar filesize in bytes";
			case TsPermission.i_client_max_channel_subscriptions: return "Max channel subscriptions";
			case TsPermission.b_client_is_priority_speaker: return "Client is priority speaker";
			case TsPermission.b_client_skip_channelgroup_permissions: return "Ignore channel group permissions";
			case TsPermission.b_client_force_push_to_talk: return "Force Push-To-Talk capture mode";
			case TsPermission.b_client_ignore_bans: return "Ignore bans";
			case TsPermission.b_client_ignore_antiflood: return "Ignore antiflood measurements";
			case TsPermission.b_client_issue_client_query_command: return "Issue query commands from client";
			case TsPermission.b_client_use_reserved_slot: return "Use an reserved slot";
			case TsPermission.b_client_use_channel_commander: return "Use channel commander";
			case TsPermission.b_client_request_talker: return "Allow to request talk power";
			case TsPermission.b_client_avatar_delete_other: return "Allow deletion of avatars from other clients";
			case TsPermission.b_client_is_sticky: return "Client will be sticked to current channel";
			case TsPermission.b_client_ignore_sticky: return "Client ignores sticky flag";
			case TsPermission.b_client_info_view: return "Retrieve client information";
			case TsPermission.b_client_permissionoverview_view: return "Retrieve client permissions overview";
			case TsPermission.b_client_permissionoverview_own: return "Retrieve clients own permissions overview";
			case TsPermission.b_client_remoteaddress_view: return "View client IP address and port";
			case TsPermission.i_client_serverquery_view_power: return "ServerQuery view power";
			case TsPermission.i_client_needed_serverquery_view_power: return "Needed ServerQuery view power";
			case TsPermission.b_client_custom_info_view: return "View custom fields";
			case TsPermission.i_client_kick_from_server_power: return "Client kick power from server";
			case TsPermission.i_client_needed_kick_from_server_power: return "Needed client kick power from server";
			case TsPermission.i_client_kick_from_channel_power: return "Client kick power from channel";
			case TsPermission.i_client_needed_kick_from_channel_power: return "Needed client kick power from channel";
			case TsPermission.i_client_ban_power: return "Client ban power";
			case TsPermission.i_client_needed_ban_power: return "Needed client ban power";
			case TsPermission.i_client_move_power: return "Client move power";
			case TsPermission.i_client_needed_move_power: return "Needed client move power";
			case TsPermission.i_client_complain_power: return "Complain power";
			case TsPermission.i_client_needed_complain_power: return "Needed complain power";
			case TsPermission.b_client_complain_list: return "Show complain list";
			case TsPermission.b_client_complain_delete_own: return "Delete own complains";
			case TsPermission.b_client_complain_delete: return "Delete complains";
			case TsPermission.b_client_ban_list: return "Show banlist";
			case TsPermission.b_client_ban_create: return "Add a ban";
			case TsPermission.b_client_ban_delete_own: return "Delete own bans";
			case TsPermission.b_client_ban_delete: return "Delete bans";
			case TsPermission.i_client_ban_max_bantime: return "Max bantime";
			case TsPermission.i_client_private_textmessage_power: return "Client private message power";
			case TsPermission.i_client_needed_private_textmessage_power: return "Needed client private message power";
			case TsPermission.b_client_server_textmessage_send: return "Send text messages to virtual server";
			case TsPermission.b_client_channel_textmessage_send: return "Send text messages to channel";
			case TsPermission.b_client_offline_textmessage_send: return "Send offline messages to clients";
			case TsPermission.i_client_talk_power: return "Client talk power";
			case TsPermission.i_client_needed_talk_power: return "Needed client talk power";
			case TsPermission.i_client_poke_power: return "Client poke power";
			case TsPermission.i_client_needed_poke_power: return "Needed client poke power";
			case TsPermission.b_client_set_flag_talker: return "Set the talker flag for clients and allow them to speak";
			case TsPermission.i_client_whisper_power: return "Client whisper power";
			case TsPermission.i_client_needed_whisper_power: return "Client needed whisper power";
			case TsPermission.b_client_modify_description: return "Edit a clients description";
			case TsPermission.b_client_modify_own_description: return "Allow client to edit own description";
			case TsPermission.b_client_modify_dbproperties: return "Edit a clients properties in the database";
			case TsPermission.b_client_delete_dbproperties: return "Delete a clients properties in the database";
			case TsPermission.b_client_create_modify_serverquery_login: return "Create or modify own ServerQuery account";
			case TsPermission.b_ft_ignore_password: return "Browse files without channel password";
			case TsPermission.b_ft_transfer_list: return "Retrieve list of running filetransfers";
			case TsPermission.i_ft_file_upload_power: return "File upload power";
			case TsPermission.i_ft_needed_file_upload_power: return "Needed file upload power";
			case TsPermission.i_ft_file_download_power: return "File download power";
			case TsPermission.i_ft_needed_file_download_power: return "Needed file download power";
			case TsPermission.i_ft_file_delete_power: return "File delete power";
			case TsPermission.i_ft_needed_file_delete_power: return "Needed file delete power";
			case TsPermission.i_ft_file_rename_power: return "File rename power";
			case TsPermission.i_ft_needed_file_rename_power: return "Needed file rename power";
			case TsPermission.i_ft_file_browse_power: return "File browse power";
			case TsPermission.i_ft_needed_file_browse_power: return "Needed file browse power";
			case TsPermission.i_ft_directory_create_power: return "Create directory power";
			case TsPermission.i_ft_needed_directory_create_power: return "Needed create directory power";
			case TsPermission.i_ft_quota_mb_download_per_client: return "Download quota per client in MByte";
			case TsPermission.i_ft_quota_mb_upload_per_client: return "Upload quota per client in MByte";
			default: throw Tools.UnhandledDefault(permid);
			}
		}
	}
}